% synthesis linear motion blur with two layers
imgn = 'img3';

img_BG = double(imread('./peppers256.png'));
img_FG = double(imread('./lena256_f.png'));
img_mask = double(imread('./lena256_mask.png'))/255;
[h w c] = size(img_FG);

% foreground generation
PSF_fg = fspecial('motion',12, 120);
img_fm = img_FG .* repmat(img_mask, [1 1 3]);
img_fblur = imfilter(img_fm, PSF_fg, 'replicate', 'same', 'conv');
%shift down the foreground
sy = 230;
sx = 248;
img_fblur2 = zeros(h, w, 3);
img_fblur2(h-sy:h, w-sx:w,:) = img_fblur(1:sy+1, 1:sx+1,:);

% background generation
PSF_bg = fspecial('motion',15, 0);
img_BG = imfilter(img_BG, PSF_bg, 'replicate', 'same', 'conv');

% merge together
img_mblur = imfilter(img_mask, PSF_fg, 'replicate', 'same', 'conv');
img_mblur2 = zeros(h, w);
img_mblur2(h-sy:h, w-sx:w) = img_mblur(1:sy+1, 1:sx+1);
img_syn = img_BG .* ( 1-repmat(img_mblur2, [1 1 3]) ) + img_fblur2;
imwrite(uint8(img_syn), ['./' imgn '.png']);
%imshow(uint8(img_syn));